.\"	$NetBSD$
.\"
.\" Copyright (c) 2001-2003 The Open Group, All Rights Reserved
.\"
.Dd January 5, 2009
.Dt MQ_SETATTR 3
.Os
.Sh NAME
.Nm mq_setattr
.Nd set message queue attributes (REALTIME)
.Sh LIBRARY
.Lb librt
.Sh SYNOPSIS
.In mqueue.h
.Ft int
.Fo mq_setattr
.Fa "mqd_t mqdes"
.Fa "const struct mq_attr *restrict mqstat"
.Fa "struct mq_attr *restrict omqstat"
.Fc
.Sh DESCRIPTION
The
.Fn mq_setattr
function sets attributes associated with the open message queue
description referenced by the message queue descriptor specified by
.Fa mqdes .
.Pp
The message queue attributes corresponding to the following members
defined in the
.Vt mq_attr
structure will be set to the specified values upon successful completion of
.Fn mq_setattr :
.Bl -tag -width mq_flags
.It Va mq_flags
The value of this member is the bitwise-logical OR of zero or more of
.Dv O_NONBLOCK
and any implementation-defined flags.
.El
.Pp
The values of the
.Va mq_maxmsg ,
.Va mq_msgsize ,
and
.Va mq_curmsgs
members of the
.Vt mq_attr
structure will be ignored by
.Fn mq_setattr .
.Pp
If
.Fa omqstat
is
.No non- Ns Dv NULL ,
the
.Fn mq_setattr
function will store, in the location referenced by
.Fa omqstat
the previous message queue attributes and the current queue status.
These values are the same as would be returned by a call to
.Xr mq_getattr 3
at that point.
.Sh RETURN VALUES
Upon successful completion, the
.Fn mq_setattr
function returns zero and the attributes of the message queue will
have been changed as specified.
Otherwise, the message queue attributes are unchanged,
and the function returns a value of
\-1 and sets the global variable
.Va errno
to indicate the error.
.Sh ERRORS
The
.Fn mq_setattr
function fails if:
.Bl -tag -width Er
.It Bq Er EBADF
The
.Fa mqdes
argument is not a valid message queue descriptor.
.El
.Sh SEE ALSO
.Xr mq_close 3 ,
.Xr mq_getattr 3 ,
.Xr mq_notify 3 ,
.Xr mq_open 3 ,
.Xr mq_receive 3 ,
.Xr mq_send 3 ,
.Xr mq_unlink 3
.Sh STANDARDS
This function conforms to the
.St -p1003.1-2001
standard.
.Sh HISTORY
This function first appeared in
.Nx 5.0 .
.Sh COPYRIGHT
Portions of this text are reprinted and reproduced in electronic form
from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology
-- Portable Operating System Interface (POSIX), The Open Group Base
Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of
Electrical and Electronics Engineers, Inc and The Open Group.
In the
event of any discrepancy between this version and the original IEEE and
The Open Group Standard, the original IEEE and The Open Group Standard
is the referee document.
The original Standard can be obtained online at
http://www.opengroup.org/unix/online.html .
